diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
index cb2fcd017..1a8f9e816 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
@@ -2,9 +2,8 @@ package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.core.Global;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
@@ -33,16 +32,9 @@ public class ParticleFluidDrip extends Particle {
         this.bCol = Color.blueFromInt(color) / 255f;
     }
 
-    @Override
-    public int getParticleTexture() {
-        return ParticleEngine.TERRAIN_TEXTURE;
-    }
-
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -67,15 +59,10 @@ public class ParticleFluidDrip extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
index e8dced1a6..f37a469dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFootstep.java
@@ -1,13 +1,14 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class ParticleFootstep extends Particle {
     private int life;
@@ -23,15 +24,15 @@ public class ParticleFootstep extends Particle {
     }
 
     @Override
-    public void renderLit(@NotNull Tessellator t, float partialTick, double xOff, double yOff, double zOff) {
-        float time = (life + partialTick) / lifeTime;
+    public void renderLit(@NotNull TessellatorGeneral t, float partialTick, double xOff, double yOff, double zOff) {
+        float time = (this.life + partialTick) / this.lifeTime;
         time *= time;
         float a = 2.0F - time * 2.0F;
         if (a > 1.0F) {
             a = 1.0F;
         }
         a *= 0.2F;
-        GL11.glDisable(GL11.GL_LIGHTING);
+        GLRenderer.globalSetLightEnabled(false);
         float s = 0.125F;
         float x = (float) (this.x - xOff);
         float y = (float) (this.y - yOff);
@@ -39,24 +40,22 @@ public class ParticleFootstep extends Particle {
         float br = this.world.getLightBrightness(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
         this.textureManager.bindTexture(this.textureManager.loadTexture("/assets/minecraft/textures/misc/footprint.png"));
 
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         t.startDrawingQuads();
-        t.setColorRGBA_F(br, br, br, a);
+        t.setColor4f(br, br, br, a);
         t.addVertexWithUV(x - s, y, z + s, 0.0D, 1.0D);
         t.addVertexWithUV(x + s, y, z + s, 1.0D, 1.0D);
         t.addVertexWithUV(x + s, y, z - s, 1.0D, 0.0D);
         t.addVertexWithUV(x - s, y, z - s, 0.0D, 0.0D);
         t.draw();
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_LIGHTING);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.globalSetLightEnabled(true);
     }
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.life++;
         if (this.life == this.lifeTime) {
             this.remove();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
index bd8b76ffd..eb7478e3d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -28,7 +27,7 @@ public class ParticleHeart extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -42,9 +41,7 @@ public class ParticleHeart extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
index 9ed67d757..e7bdc13e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
@@ -1,10 +1,8 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.util.helper.MathHelper;
@@ -21,20 +19,10 @@ public class ParticleItemBreaking extends Particle {
     }
 
     @Override
-    public int getParticleTexture() {
-        return ParticleEngine.ITEM_TEXTURE;
-    }
-
-    @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
-        if (tex == null) return;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
+        if (this.tex == null) return;
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
index 07253c603..b8aff2cfe 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -29,7 +28,7 @@ public class ParticleLava extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = (this.age + partialTick) / this.lifetime;
         this.size = this.oSize * (1.0F - l * l);
         super.render(t, partialTick);
@@ -37,9 +36,7 @@ public class ParticleLava extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index f67c6bfb3..5f8b6b132 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -1,11 +1,9 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
@@ -26,7 +24,6 @@ public class ParticleLeaf extends Particle {
         this.zd = 0.0f;
     }
 
-    // TODO readd programatic collisions
     @Override
     public boolean collidesWithBlock(@NotNull Block<?> block, int data) {
         return !Block.hasLogicClass(block, BlockLogicLeavesBase.class);
@@ -44,9 +41,7 @@ public class ParticleLeaf extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
         float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
 
@@ -71,20 +66,10 @@ public class ParticleLeaf extends Particle {
     }
 
     @Override
-    public int getParticleTexture() {
-        return ParticleEngine.TERRAIN_TEXTURE;
-    }
-
-    @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
index 20bc1f4ac..dec30e89f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.particle;
 
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -33,7 +32,7 @@ public class ParticleNote extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -47,9 +46,7 @@ public class ParticleNote extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
index ab701af53..b2aa91c2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
@@ -1,14 +1,13 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class ParticlePickupAnimation extends Particle {
     private final Entity item;
@@ -27,7 +26,7 @@ public class ParticlePickupAnimation extends Particle {
     }
 
     @Override
-    public void renderLit(@NotNull Tessellator t, float partialTick, double xOff, double yOff, double zOff) {
+    public void renderLit(@NotNull TessellatorGeneral t, float partialTick, double xOff, double yOff, double zOff) {
         float time = (this.life + partialTick) / this.lifeTime;
         time *= time;
         double xo = this.item.x;
@@ -43,21 +42,14 @@ public class ParticlePickupAnimation extends Particle {
         xx -= xOff;
         yy -= yOff;
         zz -= zOff;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            LightmapHelper.setLightmapCoord(this.item.world.getLightmapCoord(tilePos, 0));
-        } else {
-            br = this.world.getLightBrightness(tilePos);
-        }
-        GL11.glColor4f(br, br, br, 1.0F);
-        EntityRenderDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float) xx, (float) yy, (float) zz, this.item.yRot, partialTick);
+        GLRenderer.setLightmapCoord1i(this.item.world.getLightmapCoord(tilePos, 0));
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        EntityRendererDispatcher.instance.renderEntityWithPosYaw(t, this.item, (float) xx, (float) yy, (float) zz, this.item.yRot, partialTick);
     }
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.life++;
         if (this.life == this.lifeTime) {
             remove();
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
index 6f64641d6..6019c3626 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Color;
@@ -35,7 +34,7 @@ public class ParticlePortal extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float s = (this.age + partialTick) / this.lifetime;
         s = 1.0F - s;
         s *= s;
@@ -55,9 +54,7 @@ public class ParticlePortal extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
index 8a5c67f02..41d456651 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.MathHelper;
@@ -38,7 +38,7 @@ public class ParticlePuffRGB extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -48,22 +48,17 @@ public class ParticlePuffRGB extends Particle {
         }
         this.size = this.oSize * l;
         if (this.tex == null) return;
-        float br = 1f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            int xTile = MathHelper.floor(this.x);
-            int yTile = MathHelper.floor(this.y);
-            int zTile = MathHelper.floor(this.z);
-            int lmc;
-            if (this.brightness >= 0) {
-                lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
-            } else {
-                lmc = getLightmap(partialTick);
-            }
-            t.setLightmapCoord(lmc);
+        int xTile = MathHelper.floor(this.x);
+        int yTile = MathHelper.floor(this.y);
+        int zTile = MathHelper.floor(this.z);
+        int lmc;
+        if (this.brightness >= 0) {
+            lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
         } else {
-            br = Math.max(getBrightness(partialTick), this.brightness / 15f);
+            lmc = getLightmap(partialTick);
         }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(lmc);
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
@@ -73,9 +68,7 @@ public class ParticlePuffRGB extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
index 0760ffecd..97c8ee12e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.enums.LightLayer;
@@ -46,7 +46,7 @@ public class ParticleRedstoneDust extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
@@ -56,22 +56,17 @@ public class ParticleRedstoneDust extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        float br = 1f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            int xTile = MathHelper.floor(this.x);
-            int yTile = MathHelper.floor(this.y);
-            int zTile = MathHelper.floor(this.z);
-            int lmc;
-            if (this.brightness >= 0) {
-                lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
-            } else {
-                lmc = getLightmap(partialTick);
-            }
-            t.setLightmapCoord(lmc);
+        int xTile = MathHelper.floor(this.x);
+        int yTile = MathHelper.floor(this.y);
+        int zTile = MathHelper.floor(this.z);
+        int lmc;
+        if (this.brightness >= 0) {
+            lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
         } else {
-            br = Math.max(getBrightness(partialTick), this.brightness / 15f);
+            lmc = getLightmap(partialTick);
         }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(lmc);
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
@@ -83,9 +78,7 @@ public class ParticleRedstoneDust extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
index 6d93410e7..edc08c51d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
@@ -1,10 +1,8 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -21,20 +19,11 @@ public class ParticleSlimeChunk extends Particle {
     }
 
     @Override
-    public int getParticleTexture() {
-        return ParticleEngine.ITEM_TEXTURE;
-    }
-
-    @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
         float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol * br, this.gCol * br, this.bCol * br);
         t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
index fab34eb00..1c15b7412 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -30,7 +30,7 @@ public class ParticleSmoke extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
index ecfb347a6..e89fe76f4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -31,7 +31,7 @@ public class ParticleSnowShovel extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if(l < 0.0F) {
             l = 0.0F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/BlendFactor.java b/game/client/src/main/java/net/minecraft/client/render/renderer/BlendFactor.java
new file mode 100644
index 000000000..09a04cc3c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/BlendFactor.java
@@ -0,0 +1,31 @@
+package net.minecraft.client.render.renderer;
+
+import org.lwjgl.opengl.GL41;
+
+public enum BlendFactor {
+    ONE(GL41.GL_ONE),
+    ZERO(GL41.GL_ZERO),
+    SRC_COLOR(GL41.GL_SRC_COLOR),
+    ONE_MINUS_SRC_COLOR(GL41.GL_ONE_MINUS_SRC_COLOR),
+    DST_COLOR(GL41.GL_DST_COLOR),
+    ONE_MINUS_DST_COLOR(GL41.GL_ONE_MINUS_DST_COLOR),
+    SRC_ALPHA(GL41.GL_SRC_ALPHA),
+    ONE_MINUS_SRC_ALPHA(GL41.GL_ONE_MINUS_SRC_ALPHA),
+    DST_ALPHA(GL41.GL_DST_ALPHA),
+    ONE_MINUS_DST_ALPHA(GL41.GL_ONE_MINUS_DST_ALPHA),
+    CONSTANT_COLOR(GL41.GL_CONSTANT_COLOR),
+    ONE_MINUS_CONSTANT_COLOR(GL41.GL_ONE_MINUS_CONSTANT_COLOR),
+    CONSTANT_ALPHA(GL41.GL_CONSTANT_ALPHA),
+    ONE_MINUS_CONSTANT_ALPHA(GL41.GL_ONE_MINUS_CONSTANT_ALPHA),
+    SRC_ALPHA_SATURATE(GL41.GL_SRC_ALPHA_SATURATE),
+    SRC1_COLOR(GL41.GL_SRC1_COLOR),
+    ONE_MINUS_SRC1_COLOR(GL41.GL_ONE_MINUS_SRC1_COLOR),
+    SRC1_ALPHA(GL41.GL_SRC1_ALPHA),
+    ONE_MINUS_SRC1_ALPHA(GL41.GL_ONE_MINUS_SRC1_ALPHA);;
+
+    public final int cap;
+
+    BlendFactor(int cap) {
+        this.cap = cap;
+    }
+}
